
///////////////////////////////////////////////////////////////////////////////
//
//	level_banui.cpp
//

#include <stdio.h>
#include <string>
#include "id.h"
#include "project.h"

#ifdef _MSC_VER
#include <uxtheme.h>
#endif

LevelBananasManager::LevelBananasManager(LevelManager *_level, ProjectManager *_project)
: level(_level), project(_project), banana_set(_project), bDragging(false)
{
	hpnBananaLine	= NULL;
	hpnBananaSel	= NULL;
	hbrBananaRect	= NULL;
	hbrBananaLine	= NULL;
	hbrBananaSel	= NULL;
	hftBananaText	= NULL;
	hilBananaImage	= NULL;
}

LevelBananasManager::~LevelBananasManager(){
	if (hpnBananaLine)	DeleteObject(hpnBananaLine);
	if (hpnBananaSel)	DeleteObject(hpnBananaSel);
	if (hbrBananaRect)	DeleteObject(hbrBananaRect);
	if (hbrBananaLine)	DeleteObject(hbrBananaLine);
	if (hbrBananaSel)	DeleteObject(hbrBananaSel);
	if (hftBananaText)	DeleteObject(hftBananaText);
	if (hilBananaImage)	ImageList_Destroy(hilBananaImage);
}

BOOL LevelBananasManager::create(HWND hwTab){
	if (!create_dialog(hwTab)) return FALSE;
	return TRUE;
}

void LevelBananasManager::set_state(bool bEnabled){
	EnableWindow(GetDlgItem(hWnd, IDC_LIST0), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_EDIT0), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_EDIT1), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_EDIT2), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_COMBO0), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_BUTTON1), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_BUTTON4), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_BUTTON5), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_BUTTON6), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_STATIC0), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_STATIC1), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_STATIC2), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_STATIC3), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_STATIC4), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_CHECK0), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_CHECK1), bEnabled);
	return;
}

BOOL LevelBananasManager::Proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	switch (msg){
		case WM_INITDIALOG:
			{
#ifdef _MSC_VER
				HMODULE hMod;
				hMod = LoadLibrary("uxtheme.dll");
				if (hMod)
				{
					typedef HRESULT (WINAPI *EnableThemeDialogTexturePROC)(HWND, DWORD);
					EnableThemeDialogTexturePROC pEnableThemeDialogTexture;
					pEnableThemeDialogTexture = (EnableThemeDialogTexturePROC)GetProcAddress(hMod, "EnableThemeDialogTexture");
					if (pEnableThemeDialogTexture)
						pEnableThemeDialogTexture(hWnd, ETDT_ENABLETAB);
					FreeLibrary(hMod);
				}
#endif
				SetWindowLong(GetDlgItem(hDlg, IDC_EDIT0), GWL_EXSTYLE, 0);
				char s[256];
				HWND hwCombo = GetDlgItem(hDlg, IDC_COMBO0);
				SendMessage(hwCombo, WM_SETREDRAW, (WPARAM)FALSE, 0);
				SendMessage(hwCombo, CB_RESETCONTENT, 0, 0);
				for (int i=0; i<project->bananas.get_banana_set_count(); i++){
					sprintf_s(s, sizeof s, "%02X: %s", i, project->bananas.get_banana_set_name(i));
					SendMessage(hwCombo, CB_INSERTSTRING, (WPARAM)i, (LPARAM)s);
				}
				banana_set.set_window(GetDlgItem(hDlg, IDC_STATIC4));
				SendMessage(hwCombo, WM_SETREDRAW, (WPARAM)TRUE, 0);
				unable_edit_change = false;
			}
			return TRUE;
		case WM_COMMAND:
			switch (LOWORD(wParam)){
				case IDC_LIST0:
					if (HIWORD(wParam) == LBN_SELCHANGE){
						int sel = SendDlgItemMessage(hDlg, IDC_LIST0, LB_GETCURSEL, 0, 0);
						sel_changed(sel);
						if (iShowBananas != BAN_HIDE){
							isel = sel;
							level->excluse_pages(LEVEL_BANANAS);
							level->redraw_default();
						}
						return TRUE;
					}
					if (HIWORD(wParam) == LBN_DBLCLK){
						jump(SendDlgItemMessage(hDlg, IDC_LIST0, LB_GETCURSEL, 0, 0));
						return TRUE;
					}
					break;
				case IDC_EDIT1:
					if (HIWORD(wParam) == EN_CHANGE && !unable_edit_change){
						SetDlgItemText(hWnd, IDC_STATIC1, "XW(&X)*:");
						return TRUE;
					}
					break;
				case IDC_EDIT2:
					if (HIWORD(wParam) == EN_CHANGE && !unable_edit_change){
						SetDlgItemText(hWnd, IDC_STATIC2, "YW(&Y)*:");
						return TRUE;
					}
					break;
				case IDC_COMBO0:
					if (HIWORD(wParam) == CBN_SELCHANGE){
						SetDlgItemText(hWnd, IDC_STATIC3, "(&T)*:");
						banana_set.output((BYTE)SendDlgItemMessage(hDlg, IDC_COMBO0, CB_GETCURSEL, 0, 0));
						return TRUE;
					}
					break;
				case IDC_BUTTON1:	// Kp
					ban_apply(SendDlgItemMessage(hDlg, IDC_LIST0, LB_GETCURSEL, 0, 0));
					return TRUE;
				case IDC_BUTTON4:	// 
					ban_up(SendDlgItemMessage(hDlg, IDC_LIST0, LB_GETCURSEL, 0, 0));
					return TRUE;
				case IDC_BUTTON5:	// 
					ban_down(SendDlgItemMessage(hDlg, IDC_LIST0, LB_GETCURSEL, 0, 0));
					return TRUE;
				case IDC_BUTTON6:	// \[g
					ban_sort(SendDlgItemMessage(hDlg, IDC_LIST0, LB_GETCURSEL, 0, 0));
					return TRUE;
			}
			break;
	}
	return FALSE;
}

void LevelBananasManager::ban_apply(int sel){
	char s[256], s2[256];
	LevelBananasData::iterator i_sel = get_iterator(sel), i_end = data.end();
	if (i_sel == i_end) return;
	BananaAllocData banana_before = *i_sel;
	input_banana_data(&*i_sel);
	output_banana_data(&*i_sel, sel);
	// ROMf[^ɔf
	LADRS adrs_levels = get_banana_levels_adrs();
	SADRS adrs_bananas = adrs_levels.adrs + project->read_word(adrs_levels.bank, adrs_levels.adrs + level_num*2);
	(*i_sel).store_data(project, adrs_levels.bank, adrs_bananas+sel*BananaAllocData::size, level->get_code());
	// Xgɔf
	get_banana_text(s2, sizeof s2, &*i_sel);
	sprintf_s(s, sizeof s, "#%d: %s", isel, s2);
	HWND hwList = GetDlgItem(hWnd, IDC_LIST0);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)FALSE, 0);
	SendMessage(hwList, LB_DELETESTRING, (WPARAM)sel, 0);
	SendMessage(hwList, LB_INSERTSTRING, (WPARAM)sel, (LPARAM)s);
	SendMessage(hwList, LB_SETCURSEL, (WPARAM)sel, 0);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)TRUE, 0);
	level->redraw_default();
	// Undoobt@֒ǉ
	LevelBananaApply_UndoMethod *undo = new LevelBananaApply_UndoMethod(project, level, this,
		level_num, sel,	&banana_before, &*i_sel);
	project->undo_buffer.add_method(undo);
	return;
}

void LevelBananasManager::ban_up(int sel){
	char s[128], s2[128];
	if (sel <= 0) return;
	LevelBananasData::iterator i_sel = get_iterator(sel), i_otr, i_end = data.end();
	if (i_sel == i_end) return;
	// Undoobt@֒ǉ
	LevelBananaUp_UndoMethod *undo = new LevelBananaUp_UndoMethod(project, level, this, level_num, sel);
	project->undo_buffer.add_method(undo);
	BananaAllocData banana_temp = *i_sel;
	i_otr = i_sel--;
	*i_otr = *i_sel;
	*i_sel = banana_temp;
	sel--;
	if (isel != -1) isel = sel;
	HWND hwList = GetDlgItem(hWnd, IDC_LIST0);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)FALSE, 0);
	SendMessage(hwList, LB_DELETESTRING, (WPARAM)sel, 0);
	SendMessage(hwList, LB_DELETESTRING, (WPARAM)sel, 0);
	get_banana_text(s, sizeof s, &(*i_sel));
	sprintf_s(s2, sizeof s2, "#%d: %s", sel, s);
	SendMessage(hwList, LB_INSERTSTRING, (WPARAM)sel, (LPARAM)s2);
	get_banana_text(s, sizeof s, &(*i_otr));
	sprintf_s(s2, sizeof s2, "#%d: %s", sel+1, s);
	SendMessage(hwList, LB_INSERTSTRING, (WPARAM)(sel+1), (LPARAM)s2);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)TRUE, 0);
	SendMessage(hwList, LB_SETCURSEL, (WPARAM)sel, 0);
	// ROMɔf
	LADRS adrs_levels = get_banana_levels_adrs();
	SADRS adrs_bananas = adrs_levels.adrs + project->read_word(adrs_levels.bank, adrs_levels.adrs + level_num*2);
	(*i_sel).store_data(project, adrs_levels.bank, adrs_bananas+sel*BananaAllocData::size, level->get_code());
	(*i_otr).store_data(project, adrs_levels.bank, adrs_bananas+(sel+1)*BananaAllocData::size, level->get_code());
	sprintf_s(s, sizeof s, "%d", sel);
	SetDlgItemText(hWnd, IDC_EDIT0, s);
	level->redraw_default();
	return;
}

void LevelBananasManager::ban_down(int sel){
	char s[128], s2[128];
	if (sel < 0 || sel >= (int)(data.get_banana_count())-1) return;
	LevelBananasData::iterator i_sel = get_iterator(sel), i_otr, i_end = data.end();
	if (i_sel == i_end) return;
	// Undoobt@֒ǉ
	LevelBananaDown_UndoMethod *undo = new LevelBananaDown_UndoMethod(project, level, this, level_num, sel);
	project->undo_buffer.add_method(undo);
	BananaAllocData banana_temp = *i_sel;
	i_otr = i_sel++;
	*i_otr = *i_sel;
	*i_sel = banana_temp;
	sel++;
	if (isel != -1) isel = sel;
	HWND hwList = GetDlgItem(hWnd, IDC_LIST0);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)FALSE, 0);
	SendMessage(hwList, LB_DELETESTRING, (WPARAM)sel, 0);
	get_banana_text(s, sizeof s, &(*i_sel));
	sprintf_s(s2, sizeof s2, "#%d: %s", sel, s);
	SendMessage(hwList, LB_INSERTSTRING, (WPARAM)sel, (LPARAM)s2);
	SendMessage(hwList, LB_DELETESTRING, (WPARAM)(sel-1), 0);
	get_banana_text(s, sizeof s, &(*i_otr));
	sprintf_s(s2, sizeof s2, "#%d: %s", sel+1, s);
	SendMessage(hwList, LB_INSERTSTRING, (WPARAM)(sel-1), (LPARAM)s2);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)TRUE, 0);
	SendMessage(hwList, LB_SETCURSEL, (WPARAM)sel, 0);
	// ROMɔf
	LADRS adrs_levels = get_banana_levels_adrs();
	SADRS adrs_bananas = adrs_levels.adrs + project->read_word(adrs_levels.bank, adrs_levels.adrs + level_num*2);
	(*i_sel).store_data(project, adrs_levels.bank, adrs_bananas+sel*BananaAllocData::size, level->get_code());
	(*i_otr).store_data(project, adrs_levels.bank, adrs_bananas+(sel-1)*BananaAllocData::size, level->get_code());
	sprintf_s(s, sizeof s, "%d", sel);
	SetDlgItemText(hWnd, IDC_EDIT0, s);
	level->redraw_default();
	return;
}

void LevelBananasManager::ban_sort(int sel){
	int n, m;
	char s[256], s2[256];
	HWND hwList = GetDlgItem(hWnd, IDC_LIST0);
	LevelBananasData data_before(data);
	int sel_before = sel;
	BananaAllocData banana_temp;
	LevelBananasData::iterator i1, i2, i_end = data.end();
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)FALSE, 0);
	for (i1=data.begin(), n=0; i1!=i_end; i1++, n++){
		for (i2=i1++, m=n+1; i1!=i_end; i1++, m++){
			if (((*i2).pdx == (*i1).pdx) ? ((*i2).pdy > (*i1).pdy) : ((*i2).pdx > (*i1).pdx)){
				banana_temp = *i2;
				*i2 = *i1;
				*i1 = banana_temp;
				if (n == sel){
					sel = m;
				}else if (m == sel){
					sel = n;
				}
			}
		}
		i1 = i2;
		SendMessage(hwList, LB_DELETESTRING, (WPARAM)n, 0);
		get_banana_text(s, sizeof s, &*i1);
		sprintf_s(s2, sizeof s2, "#%d: %s", n, s);
		SendMessage(hwList, LB_INSERTSTRING, (WPARAM)n, (LPARAM)s2);
	}
	if (isel != -1) isel = sel;
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)TRUE, 0);
	SendMessage(hwList, LB_SETCURSEL, (WPARAM)sel, 0);
	// ROMɔf
	LADRS adrs_levels = get_banana_levels_adrs();
	data.store_data(project, adrs_levels.bank, adrs_levels.adrs, level_num, level->get_code());
	level->redraw_default();
	if (sel != -1){
		sprintf_s(s, sizeof s, "%d", sel);
		SetDlgItemText(hWnd, IDC_EDIT0, s);
	}
	// Undoobt@֒ǉ
	LevelBananaSort_UndoMethod *undo = new LevelBananaSort_UndoMethod(project, level, this, level_num,
		sel_before, sel, data_before, data);
	project->undo_buffer.add_method(undo);
	return;
}

void LevelBananasManager::sel_changed(int sel){
	LevelBananasData::iterator i_sel = get_iterator(sel), i_end = data.end();
	if (i_sel == i_end) return;
	output_banana_data(&*i_sel, sel);
	return;
}

void LevelBananasManager::input_banana_data(BananaAllocData *banana){
	char s[256];
	int ivalue;
	GetDlgItemText(hWnd, IDC_EDIT1, s, sizeof s);
	if (sscanf_s(s, "%d", &ivalue) <= 0) ivalue = 0;
	banana->pdx = ivalue;
	GetDlgItemText(hWnd, IDC_EDIT2, s, sizeof s);
	if (sscanf_s(s, "%d", &ivalue) <= 0) ivalue = 0;
	banana->pdy = ivalue;
	banana->type = (BYTE)SendDlgItemMessage(hWnd, IDC_COMBO0, CB_GETCURSEL, 0, 0);
	banana->fore = IsDlgButtonChecked(hWnd, IDC_CHECK0) != FALSE;
	banana->fore2= IsDlgButtonChecked(hWnd, IDC_CHECK1) != FALSE;
	banana->normalize(level->get_code());
	SetDlgItemText(hWnd, IDC_STATIC1, "XW(&X):");
	SetDlgItemText(hWnd, IDC_STATIC2, "YW(&Y):");
	SetDlgItemText(hWnd, IDC_STATIC3, "(&T):");
	return;
}

void LevelBananasManager::output_banana_data(const BananaAllocData *banana, int iIndex){
	char s[256];
	unable_edit_change = true;
	sprintf_s(s, sizeof s, "%d", iIndex);
	SetDlgItemText(hWnd, IDC_EDIT0, s);
	sprintf_s(s, sizeof s, "%d", banana->pdx);
	SetDlgItemText(hWnd, IDC_EDIT1, s);
	sprintf_s(s, sizeof s, "%d", banana->pdy);
	SetDlgItemText(hWnd, IDC_EDIT2, s);
	SendDlgItemMessage(hWnd, IDC_COMBO0, CB_SETCURSEL, banana->type, 0L);
	CheckDlgButton(hWnd, IDC_CHECK0, banana->fore? TRUE : FALSE);
	CheckDlgButton(hWnd, IDC_CHECK1, banana->fore2? TRUE : FALSE);
	banana_set.output(banana->type);
	unable_edit_change = false;
	SetDlgItemText(hWnd, IDC_STATIC1, "XW(&X):");
	SetDlgItemText(hWnd, IDC_STATIC2, "YW(&Y):");
	SetDlgItemText(hWnd, IDC_STATIC3, "(&T):");
	return;
}

void LevelBananasManager::jump(int sel){
	LevelBananasData::iterator i_sel = get_iterator(sel), i_end = data.end();
	if (i_sel == i_end) return;
	level->set_scroll_pos((*i_sel).pdx, (*i_sel).pdy);
	return;
}

void LevelBananasManager::focus_on_banana(int sel){
	if (iShowBananas != BAN_HIDE){
		isel = sel;
		LevelBananasData::iterator i_sel = get_iterator(sel), i_end = data.end();
		if (i_sel == i_end) return;
		if (!level->is_point_in_screen((*i_sel).pdx, (*i_sel).pdy))
			level->set_scroll_pos((*i_sel).pdx, (*i_sel).pdy);
	}
	level->redraw_default();
	return;
}

LevelBananasData::iterator LevelBananasManager::get_iterator(int iIndex){
	LevelBananasData::iterator i, i_end = data.end();
	int n;
	for (i=data.begin(), n=0; i!=i_end; i++, n++){
		if (n == iIndex) return i;
	}
	return i_end;
}



void LevelBananasManager::release_sel(){
	isel = -1;
	return;
}

bool LevelBananasManager::mouseover(int pdx, int pdy){
	if (iShowBananas == BAN_HIDE) return false;
	char s[256];
	int x, y, n;
	LevelBananasData::reverse_iterator i, i_end = data.rend();
	for (i=data.rbegin(), n=data.get_banana_count()-1; i!=i_end; i++, n--){
		x = (*i).pdx;
		y = (*i).pdy;
		const BananaSetData *data = project->bananas.get_banana_set_data((*i).type);
		if (iShowBananas == BAN_NORMAL?(
			(pdx >= x-8 && pdx < x-3 && pdy >= y-8 && pdy < y+data->height*8+8+8)
			|| (pdx >= x+data->width*8+8+3 && pdx < x+data->width*8+8+8 && pdy >= y-8 && pdy < y+data->height*8+8+8)
			|| (pdy >= y-8 && pdy < y-3 && pdx >= x-8 && pdx < x+data->width*8+8+8)
			|| (pdy >= y+data->height*8+8+3 && pdy < y+data->height*8+8+8 && pdx >= x-8 && pdx < x+data->width*8+8+8)
			|| (pdx >= x-8 && pdx < x+data->width*8+8+8 && pdy >= y-8-18 && pdy < y-7)
			):( (pdx >= x) && (pdy >= y) && (pdx < x + BANANA_WIDTH) && (pdy < y + BANANA_HEIGHT) ))
		{
			SetCursor(LoadCursor(NULL, IDC_SIZEALL));
			sprintf_s(s, sizeof s, "oii#%d: (%d, %d)", n, (*i).pdx, (*i).pdy);
			SendMessage(project->get_hwStatus(), SB_SETTEXT, (WPARAM)STATUS_INDEX_POINTING_OBJECT, (LPARAM)s);
			get_banana_text(s, sizeof s, &(*i));
			SendMessage(project->get_hwStatus(), SB_SETTEXT, (WPARAM)STATUS_INDEX_POINTING_OBJECT_EX, (LPARAM)s);
			return true;
		}
	}
	return false;
}

bool LevelBananasManager::accepts_click(int pdx, int pdy){
	if (iShowBananas == BAN_HIDE) return false;
	int x, y, n;
	LevelBananasData::reverse_iterator i, i_end = data.rend();
	for (i=data.rbegin(), n=data.get_banana_count()-1; i!=i_end; i++, n--){
		x = (*i).pdx;
		y = (*i).pdy;
		const BananaSetData *data = project->bananas.get_banana_set_data((*i).type);
		if (iShowBananas == BAN_NORMAL?(
			(pdx >= x-8 && pdx < x-3 && pdy >= y-8 && pdy < y+data->height*8+8+8)
			|| (pdx >= x+data->width*8+8+3 && pdx < x+data->width*8+8+8 && pdy >= y-8 && pdy < y+data->height*8+8+8)
			|| (pdy >= y-8 && pdy < y-3 && pdx >= x-8 && pdx < x+data->width*8+8+8)
			|| (pdy >= y+data->height*8+8+3 && pdy < y+data->height*8+8+8 && pdx >= x-8 && pdx < x+data->width*8+8+8)
			|| (pdx >= x-8 && pdx < x+data->width*8+8+8 && pdy >= y-8-18 && pdy < y-7)
			):( (pdx >= x) && (pdy >= y) && (pdx < x + BANANA_WIDTH) && (pdy < y + BANANA_HEIGHT) ))
		{
			isel = n;
			SendMessage(GetDlgItem(hWnd, IDC_LIST0), LB_SETCURSEL, (WPARAM)isel, 0);
			sel_changed(n);
			bDragging = true;
			dragging_x = pdx - x;
			dragging_y = pdy - y;
			drag_temp_x = x;
			drag_temp_y = y;
			return true;
		}
	}
	isel = -1;
	return false;
}

void LevelBananasManager::release_click(bool bApply){
	LevelBananasData::iterator i = get_iterator(isel);
	if (i == data.end()) return;
	if (bApply) ban_apply(isel);
	bDragging = false;
	return;
}

void LevelBananasManager::dragging(int pdx, int pdy){
	char s[256];
	LevelBananasData::iterator i = get_iterator(isel);
	if (i == data.end()) return;
	drag_temp_x = (pdx - dragging_x + 4) & ~7;
	drag_temp_y = (pdy - dragging_y + 4) & ~7;
	sprintf_s(s, sizeof s, "%d", drag_temp_x);
	SetDlgItemText(hWnd, IDC_EDIT1, s);
	sprintf_s(s, sizeof s, "%d", drag_temp_y);
	SetDlgItemText(hWnd, IDC_EDIT2, s);

	sprintf_s(s, sizeof s, "oii#%d: (%d, %d)  (%d, %d)", isel, (*i).pdx, (*i).pdy, drag_temp_x, drag_temp_y);
	SendMessage(project->get_hwStatus(), SB_SETTEXT, (WPARAM)STATUS_INDEX_POINTING_OBJECT, (LPARAM)s);
	return;
}


BOOL LevelBananasManager::create_sys(){
	hilBananaImage	= ImageList_Create(16, 16, ILC_COLOR24 | ILC_MASK, 1, 0);
	{
		HBITMAP hbmBanana = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BANANA));
		banana_image_index = ImageList_AddMasked(hilBananaImage, hbmBanana, RGB(255, 255, 255));
		DeleteObject(hbmBanana);
	}
	hpnBananaLine	= CreatePen(PS_SOLID, 1, RGB(255, 255, 0));
	hpnBananaSel	= CreatePen(PS_SOLID, 3, RGB(255, 255, 128));
	hbrBananaRect	= CreateSolidBrush(RGB(0, 0, 0));
	hbrBananaLine	= CreateSolidBrush(RGB(255, 255, 0));
	hbrBananaSel	= CreateSolidBrush(RGB(128, 128, 0));
	hftBananaText	= CreateFont(12, 0, 0, 0, FW_REGULAR, FALSE, FALSE, FALSE, SHIFTJIS_CHARSET,
		OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, FIXED_PITCH | FF_MODERN, "lr SVbN");
	iShowBananas	= (ShowBananas)GetPrivateProfileInt("MapView", "ShowBananas", TRUE, ConfigFileName);
	set_menuitem_state();
	return TRUE;
}

void LevelBananasManager::set_menuitem_state(){
	MENUITEMINFO mi;
	mi.cbSize	= sizeof mi;
	mi.fMask	= MIIM_STATE;
	mi.fState	= iShowBananas==BAN_HIDE ? MFS_CHECKED : MFS_UNCHECKED;
	SetMenuItemInfo(GetMenu(project->get_hWnd()), IDM_VIEW_BAN_HIDE, FALSE, &mi);
	mi.fState	= iShowBananas==BAN_NORMAL ? MFS_CHECKED : MFS_UNCHECKED;
	SetMenuItemInfo(GetMenu(project->get_hWnd()), IDM_VIEW_BAN_NORMAL, FALSE, &mi);
	mi.fState	= iShowBananas==BAN_SIMPLE ? MFS_CHECKED : MFS_UNCHECKED;
	SetMenuItemInfo(GetMenu(project->get_hWnd()), IDM_VIEW_BAN_SIMPLE, FALSE, &mi);
	return;
}

void LevelBananasManager::save_data(){
	char s[16];
	sprintf_s(s, sizeof s, "%d", (int)iShowBananas);
	WritePrivateProfileString("MapView", "ShowBananas", s, ConfigFileName);
	return;
}

void LevelBananasManager::get_banana_text(char *dst, size_t size, const BananaAllocData *banana){
	sprintf_s(dst, size, "%02X: %s", banana->type, project->bananas.get_banana_set_name(banana->type));
	return;
}

void LevelBananasManager::load(int _level_num){
	char s[128], s2[128];
	level_num = _level_num;
	LADRS adrs_levels = get_banana_levels_adrs();
	HWND hwList = GetDlgItem(hWnd, IDC_LIST0);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)FALSE, 0);
	clear();
	data.load_data(project, adrs_levels.bank, adrs_levels.adrs, level_num, level->get_code());
	LevelBananasData::iterator i, i_end = data.end();
	int n;
	for (i=data.begin(), n=0; i!=i_end; i++, n++){
		get_banana_text(s, sizeof s, &(*i));
		sprintf_s(s2, sizeof s2, "#%d: %s", n, s);
		SendMessage(hwList, LB_INSERTSTRING, (WPARAM)n, (LPARAM)s2);
	}
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)TRUE, 0);
	isel = -1;
	return;
}


void LevelBananasManager::clear(){
	LPCSTR empty = "";
	data.clear();
	unable_edit_change = true;
	SendMessage(GetDlgItem(hWnd, IDC_LIST0), LB_RESETCONTENT, 0, 0);
	SetDlgItemText(hWnd, IDC_EDIT0, empty);
	SetDlgItemText(hWnd, IDC_EDIT1, empty);
	SetDlgItemText(hWnd, IDC_EDIT2, empty);
	CheckDlgButton(hWnd, IDC_CHECK0, FALSE);
	SendMessage(GetDlgItem(hWnd, IDC_COMBO0), CB_SETCURSEL, 0, 0);
	unable_edit_change = false;
	banana_set.clear();
	return;
}

void LevelBananasManager::draw(BitmapBuffer *buf, const RECT *rtRedraw){
	if (iShowBananas == BAN_HIDE) return;
	char s[64];
	int x, y, n;
	LevelBananasData::iterator i, i_end = data.end();
	buf->select_object(hftBananaText);
	SetBkMode(buf->get_HDC(), TRANSPARENT);
	SetTextColor(buf->get_HDC(), RGB(255, 255, 0));
	for (i=data.begin(), n=0; i!=i_end; i++, n++){
		if (bDragging && n==isel) continue;		// hbO͉
		x = (*i).pdx - rtRedraw->left;
		y = (*i).pdy - rtRedraw->top;
		if (iShowBananas == BAN_NORMAL){
			const BananaSetData *data = project->bananas.get_banana_set_data((*i).type);
			for (int ix=0; ix<data->width; ix++){
				for (int iy=0; iy<data->height; iy++){
					if (data->set[ix][iy]){
						ImageList_Draw(hilBananaImage, banana_image_index, buf->get_HDC(), x + ix*8, y + iy*8, ILD_TRANSPARENT);
					}
				}
			}
			buf->select_object(hpnBananaLine);
			buf->select_object(GetStockObject(NULL_BRUSH));
			buf->rectangle(x-8, y-8-18, x+data->width*8+8+8, y+data->height*8+8+8);
			if (n==isel){
				buf->select_object(hpnBananaSel);
				buf->select_object(GetStockObject(NULL_BRUSH));
				buf->rectangle(x-8+2, y-8+2, x+data->width*8+8+8-2, y+data->height*8+8+8-2);
			}
			buf->select_object(hpnBananaLine);
			buf->select_object(n==isel? hbrBananaSel : hbrBananaRect);
			buf->rectangle(x-8, y-8-18, x+data->width*8+8+8, y-7);
			SetTextColor(buf->get_HDC(), n==isel ? RGB(255, 255, 255) : RGB(255, 255, 0));
			sprintf_s(s, sizeof s, "#%d", n);
			TextOut(buf->get_HDC(), x-8+3, y-8-18+3, s, strlen(s));
		}else{
			POINT points[3];
			buf->select_object(hpnBananaLine);
			buf->select_object(n==isel? hbrBananaSel : hbrBananaRect);
			buf->rectangle(x, y, x + BANANA_WIDTH, y + BANANA_HEIGHT);
			points[0].x = x;
			points[0].y = y;
			points[1].x = x + 6;
			points[1].y = y;
			points[2].x = x;
			points[2].y = y + 6;
			buf->select_object(GetStockObject(NULL_PEN));
			buf->select_object(hbrBananaLine);
			Polygon(buf->get_HDC(), points, 3);
			SetTextColor(buf->get_HDC(), n==isel ? RGB(255, 255, 255) : RGB(255, 255, 0));
			sprintf_s(s, sizeof s, "#%d", n);
			TextOut(buf->get_HDC(), x+3, y+6, s, strlen(s));
			sprintf_s(s, sizeof s, "%02X", (*i).type);
			TextOut(buf->get_HDC(), x+3, y+19, s, strlen(s));
			if (n == isel){
				buf->select_object(hpnBananaSel);
				buf->select_object(GetStockObject(NULL_BRUSH));
				buf->rectangle(x-2, y-2, x+2 + BANANA_WIDTH, y+2 + BANANA_HEIGHT);
			}
		}
	}
	return;
}

void LevelBananasManager::draw_f(BitmapBuffer *buf, const RECT *rtRedraw){
	char s[64];
	int x, y;
	if (iShowBananas == BAN_HIDE) return;
	if (!bDragging) return;
	LevelBananasData::iterator i = get_iterator(isel);
	if (i == data.end()) return;
	buf->select_object(hftBananaText);
	SetBkMode(buf->get_HDC(), TRANSPARENT);
	SetTextColor(buf->get_HDC(), RGB(255, 255, 0));
	x = drag_temp_x - rtRedraw->left;
	y = drag_temp_y - rtRedraw->top;
	if (iShowBananas == BAN_NORMAL){
		const BananaSetData *data = project->bananas.get_banana_set_data((*i).type);
		for (int ix=0; ix<data->width; ix++){
			for (int iy=0; iy<data->height; iy++){
				if (data->set[ix][iy]){
					ImageList_Draw(hilBananaImage, banana_image_index, buf->get_HDC(), x + ix*8, y + iy*8, ILD_TRANSPARENT);
				}
			}
		}
		buf->select_object(hpnBananaLine);
		buf->select_object(GetStockObject(NULL_BRUSH));
		buf->rectangle(x-8, y-8-18, x+data->width*8+8+8, y+data->height*8+8+8);
		buf->select_object(hpnBananaSel);
		buf->select_object(GetStockObject(NULL_BRUSH));
		buf->rectangle(x-8+2, y-8+2, x+data->width*8+8+8-2, y+data->height*8+8+8-2);
		buf->select_object(hpnBananaLine);
		buf->select_object(hbrBananaSel);
		buf->rectangle(x-8, y-8-18, x+data->width*8+8+8, y-7);
		SetTextColor(buf->get_HDC(), RGB(255, 255, 255));
		sprintf_s(s, sizeof s, "#%d", isel);
		TextOut(buf->get_HDC(), x-8+3, y-8-18+3, s, strlen(s));
	}else{
		POINT points[3];
		buf->select_object(hpnBananaLine);
		buf->select_object(hbrBananaSel);
		buf->rectangle(x, y, x + BANANA_WIDTH, y + BANANA_HEIGHT);
		points[0].x = x;
		points[0].y = y;
		points[1].x = x + 6;
		points[1].y = y;
		points[2].x = x;
		points[2].y = y + 6;
		buf->select_object(GetStockObject(NULL_PEN));
		buf->select_object(hbrBananaLine);
		Polygon(buf->get_HDC(), points, 3);
		SetTextColor(buf->get_HDC(), RGB(255, 255, 255));
		sprintf_s(s, sizeof s, "#%d", isel);
		TextOut(buf->get_HDC(), x+3, y+6, s, strlen(s));
		sprintf_s(s, sizeof s, "%02X", (*i).type);
		TextOut(buf->get_HDC(), x+3, y+19, s, strlen(s));
		buf->select_object(hpnBananaSel);
		buf->select_object(GetStockObject(NULL_BRUSH));
		buf->rectangle(x-2, y-2, x+2 + BANANA_WIDTH, y+2 + BANANA_HEIGHT);
	}
	return;
}



BOOL LevelBananasManager::command(WPARAM wParam, LPARAM lParam){
	if (LOWORD(wParam) == IDM_VIEW_BANANAS){
		switch (iShowBananas){
			case BAN_HIDE:	 iShowBananas = BAN_NORMAL;	break;
			case BAN_NORMAL: iShowBananas = BAN_SIMPLE;	break;
			case BAN_SIMPLE: iShowBananas = BAN_HIDE;	break;
		}
		set_menuitem_state();
		if (iShowBananas == BAN_HIDE){
			isel = -1;
		}
		level->redraw_default();
		return TRUE;
	}
	if (LOWORD(wParam) == IDM_VIEW_BANANAS_I){
		switch (iShowBananas){
			case BAN_HIDE:	 iShowBananas = BAN_SIMPLE;	break;
			case BAN_NORMAL: iShowBananas = BAN_HIDE;	break;
			case BAN_SIMPLE: iShowBananas = BAN_NORMAL;	break;
		}
		set_menuitem_state();
		if (iShowBananas == BAN_HIDE){
			isel = -1;
		}
		level->redraw_default();
		return TRUE;
	}
	if (LOWORD(wParam) == IDM_VIEW_BAN_HIDE){
		iShowBananas = BAN_HIDE;
		set_menuitem_state();
		level->redraw_default();
		return TRUE;
	}
	if (LOWORD(wParam) == IDM_VIEW_BAN_NORMAL){
		iShowBananas = BAN_NORMAL;
		set_menuitem_state();
		level->redraw_default();
		return TRUE;
	}
	if (LOWORD(wParam) == IDM_VIEW_BAN_SIMPLE){
		iShowBananas = BAN_SIMPLE;
		set_menuitem_state();
		level->redraw_default();
		return TRUE;
	}
	return FALSE;
}

BOOL LevelBananasManager::translate_dialog_message(MSG *msg){
	return IsDialogMessage(hWnd, msg);
}



//---------------------------------------------------------

BananaSetWindow::BananaSetWindow(ProjectManager *_project) : project(_project){
	hfText = NULL;
}

BananaSetWindow::~BananaSetWindow(){
	if (hfText) DeleteObject(hfText);
}

void BananaSetWindow::set_window(HWND _hWnd){
	hWnd = _hWnd;
	hfText = CreateFont(6, 0, 0, 0, FW_REGULAR, FALSE, FALSE, FALSE, SHIFTJIS_CHARSET,
		OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, FIXED_PITCH | FF_MODERN, "lr SVbN");
	SendMessage(hWnd, WM_SETFONT, (WPARAM)hfText, 0);
	return;
}

void BananaSetWindow::output(BYTE type){
	const BananaSetData *data = project->bananas.get_banana_set_data(type);
	int xmax = min(data->width, BananaSetData::BNSET_WIDTH);
	int ymax = min(data->height, BananaSetData::BNSET_HEIGHT);
	std::string text;
	for (int y=0; y<ymax; y++){
		for (int x=0; x<xmax; x++){
			text += data->set[x][y] ? "" : "";
		}
		text += "\r\n";
	}
	SetWindowText(hWnd, text.c_str());
	return;
}

void BananaSetWindow::clear(){
	SetWindowText(hWnd, "");
	return;
}





