
///////////////////////////////////////////////////////////////////////////////
//
//	sprite_edtp.cpp
//

#include <windows.h>
#include <commctrl.h>
#include "sprite_edit.h"
#include "project.h"
#include "id.h"

#ifdef _MSC_VER
#include <uxtheme.h>
#endif


//	ʏ̃R}h(00xxn܂)
//-------------------------------------
class EditsprDataPage_CommandDefault : public EditsprDataPage_CommandBase{
	class MyUndoMethod : public UndoMethod{
		EditsprManager *editspr;
		SADRS adrs;
		const SpriteDataIterator itr;
		WORD value_before;
		WORD value_after;
	private:
		LPCSTR text_undo() const{ return "XvCgf[^̕ύX"; }
		LPCSTR text_redo() const{ return "XvCgf[^̕ύX"; }
		void undo(){
			common(value_before);
		}
		void redo(){
			common(value_after);
		}
		void common(WORD value){
			itr.set_value(value);							// f[^ɔf
			editspr->command(IDM_SPRITE_EDITSPR, 0);		// XvCgҏW_CAO\
			EditsprDataPage *page = editspr->open_data_page(adrs);	// adrs̃y[WJ
			page->update_command_list(itr);					// f[^y[W̃XgXV
			EditsprDataPage_CommandDefault *compage = 
				dynamic_cast<EditsprDataPage_CommandDefault*>(page->select_command_page(itr));
			if (!compage) return;
			SetFocus(GetDlgItem(compage->get_hWnd(), IDC_EDIT1));
			SendMessage(compage->get_hWnd(), WM_COMMAND, IDC_EDIT1 | (EN_SETFOCUS<<16), 0);
		}
	public:
		MyUndoMethod(EditsprManager *_editspr, SADRS _adrs, const SpriteDataIterator &_itr,
			WORD _value_before, WORD _value_after)
			: editspr(_editspr), adrs(_adrs), itr(_itr),
			value_before(_value_before), value_after(_value_after)
		{}
		~MyUndoMethod(){}
	};
	ProjectManager *project;
	SpritesManager *sprites;
	EditsprManager *editspr;
	EditsprDataPage *page;
	WORD adrs;
	const SpriteDataIterator itr;
	bool unable_edit_change;
private:
	LPCSTR get_template() const{ return "SPRITE_EDIT_DATA_PAGE_CMDDEFAULT"; }
	BOOL Proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
		switch (msg){
			case WM_INITDIALOG:
				init();
				return TRUE;
			case WM_CTLCOLORDLG:
				return (BOOL)(HBRUSH)(COLOR_3DFACE + 1);
			case WM_COMMAND:
				switch (LOWORD(wParam)){
					case IDC_EDIT1:
						switch (HIWORD(wParam)){
							case EN_CHANGE:
								edit_change();
								return TRUE;
							case EN_SETFOCUS:
								SendMessage(hWnd, DM_SETDEFID, (WPARAM)IDC_BUTTON21, 0);
								SetFocus(GetDlgItem(hWnd, IDC_BUTTON21));
								SetFocus(GetDlgItem(hWnd, IDC_EDIT1));
								return TRUE;
						}
						break;
					case IDC_BUTTON21:
						apply();
						return TRUE;
				}
				break;
		}
		return FALSE;
	}
	int get_caption_name(char *buf, size_t buf_size){
		switch (WORD command = itr.get_command()){
			case 0x8100: return strcpy_s(buf, buf_size, "OtBbNԍݒ");
			case 0x8500: return strcpy_s(buf, buf_size, "OtBbÑX^Cݒ");
			case 0x8D00: return strcpy_s(buf, buf_size, "pbgݒ");
			default:
				if ((command & 0xFF00) == 0){
					return sprintf_s(buf, buf_size, "ϐ %02X ɑ", command);
				}
				return strcpy_s(buf, buf_size, "m̃R}h");
		}
		return 0;
	}
	void init(){
		unable_edit_change = true;
		char s[256];
		get_caption_name(s, sizeof s);
		SetDlgItemText(hWnd, IDC_STATIC0, s);
		sprintf_s(s, sizeof s, "%04X", itr.get_value());
		SendDlgItemMessage(hWnd, IDC_EDIT1, EM_SETLIMITTEXT, 4, 0);
		SetDlgItemText(hWnd, IDC_EDIT1, s);
		unable_edit_change = false;
	}
	void edit_change(){
		if (unable_edit_change) return;
		char s[256];
		get_caption_name(s, sizeof s);
		int len = strlen(s);
		s[len] = '*';
		s[len+1] = '\0';
		SetDlgItemText(hWnd, IDC_STATIC0, s);
	}
	void apply(){
		char s[256];
		int val;
		GetDlgItemText(hWnd, IDC_EDIT1, s, sizeof s);
		if (sscanf_s(s, "%x", &val) < 0 || val < 0 || val > 0xFFFF){
			MessageBox(editspr->get_hWnd(), "lsłB", "G[", MB_OK | MB_ICONEXCLAMATION);
			return;
		}
		WORD bef = itr.get_value();
		itr.set_value((WORD)val);
		get_caption_name(s, sizeof s);			// LvV*
		SetDlgItemText(hWnd, IDC_STATIC0, s);
		page->update_command_list(itr);			// f[^y[W̃XgXV
		MyUndoMethod *undo = new MyUndoMethod(editspr, adrs, itr, bef, (WORD)val);
		project->undo_buffer.add_method(undo);
	}
public:
	EditsprDataPage_CommandDefault(
		ProjectManager *_project, SpritesManager *_sprites, EditsprManager *_editspr,
		EditsprDataPage *_page, SADRS _adrs, const SpriteDataIterator &_itr)
		: project(_project), sprites(_sprites), editspr(_editspr), page(_page), adrs(_adrs), itr(_itr)
	{
		create_dialog(page->get_hWnd());
	}
	~EditsprDataPage_CommandDefault(){}
};

//	R}h8300
//-------------------------------------
class EditsprDataPage_Command8300 : public EditsprDataPage_CommandBase{
	class MyUndoMethod : public UndoMethod{
		EditsprManager *editspr;
		SADRS adrs;
		const SpriteDataIterator itr;
		WORD value_before;
		WORD value_after;
	private:
		LPCSTR text_undo() const{ return "XvCgf[^̕ύX"; }
		LPCSTR text_redo() const{ return "XvCgf[^̕ύX"; }
		void undo(){
			common(value_before);
		}
		void redo(){
			common(value_after);
		}
		void common(WORD value){
			itr.set_value(value);							// f[^ɔf
			editspr->command(IDM_SPRITE_EDITSPR, 0);		// XvCgҏW_CAO\
			EditsprDataPage *page = editspr->open_data_page(adrs);	// adrs̃y[WJ
			page->update_command_list(itr);					// f[^y[W̃XgXV
			EditsprDataPage_Command8300 *compage = 
				dynamic_cast<EditsprDataPage_Command8300*>(page->select_command_page(itr));
			if (!compage) return;
			SetFocus(GetDlgItem(compage->get_hWnd(), IDC_EDIT1));
			SendMessage(compage->get_hWnd(), WM_COMMAND, IDC_EDIT1 | (EN_SETFOCUS<<16), 0);
		}
	public:
		MyUndoMethod(EditsprManager *_editspr, SADRS _adrs, const SpriteDataIterator &_itr,
			WORD _value_before, WORD _value_after)
			: editspr(_editspr), adrs(_adrs), itr(_itr),
			value_before(_value_before), value_after(_value_after)
		{}
		~MyUndoMethod(){}
	};
	ProjectManager *project;
	SpritesManager *sprites;
	EditsprManager *editspr;
	EditsprDataPage *page;
	WORD adrs;
	const SpriteDataIterator itr;
	bool unable_edit_change;
private:
	LPCSTR get_template() const{ return "SPRITE_EDIT_DATA_PAGE_CMD8300"; }
	BOOL Proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
		switch (msg){
			case WM_INITDIALOG:
				init();
				return TRUE;
			case WM_CTLCOLORDLG:
				return (BOOL)(HBRUSH)(COLOR_3DFACE + 1);
			case WM_COMMAND:
				switch (LOWORD(wParam)){
					case IDC_EDIT1:
						switch (HIWORD(wParam)){
							case EN_CHANGE:
								edit_change();
								return TRUE;
							case EN_SETFOCUS:
								SendMessage(hWnd, DM_SETDEFID, (WPARAM)IDC_BUTTON21, 0);
								SetFocus(GetDlgItem(hWnd, IDC_BUTTON21));
								SetFocus(GetDlgItem(hWnd, IDC_EDIT1));
								return TRUE;
						}
						break;
					case IDC_BUTTON20:
						edit_parent();
						return TRUE;
					case IDC_BUTTON21:
						apply();
						return TRUE;
				}
				break;
		}
		return FALSE;
	}
	void init(){
		unable_edit_change = true;
		char s[16];
		sprintf_s(s, sizeof s, "%04X", itr.get_value());
		SendDlgItemMessage(hWnd, IDC_EDIT1, EM_SETLIMITTEXT, 4, 0);
		SetDlgItemText(hWnd, IDC_EDIT1, s);
		unable_edit_change = false;
	}
	void edit_change(){
		if (unable_edit_change) return;
		SetDlgItemText(hWnd, IDC_STATIC0, "eXvCgǂݍ*");
	}
	void edit_parent(){
		char s[16];
		int val;
		GetDlgItemText(hWnd, IDC_EDIT1, s, sizeof s);
		if (sscanf_s(s, "%x", &val) < 0 || val < 0 || val > 0xFFFF){
			MessageBox(editspr->get_hWnd(), "lsłB", "G[", MB_OK | MB_ICONEXCLAMATION);
			return;
		}
		editspr->open_data_page((SADRS)val);
	}
	void apply(){
		char s[16];
		int val;
		GetDlgItemText(hWnd, IDC_EDIT1, s, sizeof s);
		if (sscanf_s(s, "%x", &val) < 0 || val < 0 || val > 0xFFFF){
			MessageBox(editspr->get_hWnd(), "lsłB", "G[", MB_OK | MB_ICONEXCLAMATION);
			return;
		}
		WORD bef = itr.get_value();
		itr.set_value((WORD)val);
		SetDlgItemText(hWnd, IDC_STATIC0, "eXvCgǂݍ");
		page->update_command_list(itr);			// f[^y[W̃XgXV
		MyUndoMethod *undo = new MyUndoMethod(editspr, adrs, itr, bef, (WORD)val);
		project->undo_buffer.add_method(undo);
	}
public:
	EditsprDataPage_Command8300(
		ProjectManager *_project, SpritesManager *_sprites, EditsprManager *_editspr,
		EditsprDataPage *_page, SADRS _adrs, const SpriteDataIterator &_itr)
		: project(_project), sprites(_sprites), editspr(_editspr),
		page(_page), adrs(_adrs), itr(_itr)
	{
		create_dialog(page->get_hWnd());
	}
	~EditsprDataPage_Command8300(){}
};

//	R}h8A00(ľʏƈقȂ)
//-------------------------------------
class EditsprDataPage_Command8A00 : public EditsprDataPage_CommandBase{
	class MyUndoMethod : public UndoMethod{
		EditsprManager *editspr;
		SADRS adrs;
		const SpriteDataIterator itr;
		WORD value_before[13];
		WORD value_after[13];
	private:
		LPCSTR text_undo() const{ return "XvCgf[^̕ύX"; }
		LPCSTR text_redo() const{ return "XvCgf[^̕ύX"; }
		void undo(){
			common(value_before);
		}
		void redo(){
			common(value_after);
		}
		void common(WORD value[13]){
			for (int i=0; i<13; i++) itr.set_value_of13(value[i], i);	// f[^ɔf
			editspr->command(IDM_SPRITE_EDITSPR, 0);					// XvCgҏW_CAO\
			EditsprDataPage *page = editspr->open_data_page(adrs);		// adrs̃y[WJ
			page->update_command_list(itr);					// f[^y[W̃XgXV
			EditsprDataPage_Command8A00 *compage = 
				dynamic_cast<EditsprDataPage_Command8A00*>(page->select_command_page(itr));
			if (!compage) return;
			SetFocus(GetDlgItem(compage->get_hWnd(), IDC_EDIT1));
			SendMessage(compage->get_hWnd(), WM_COMMAND, IDC_EDIT1 | (EN_SETFOCUS<<16), 0);
		}
	public:
		MyUndoMethod(EditsprManager *_editspr, SADRS _adrs, const SpriteDataIterator &_itr,
			WORD _value_before[13], WORD _value_after[13])
			: editspr(_editspr), adrs(_adrs), itr(_itr)
		{
			for (int i=0; i<13; i++){
				value_before[i] = _value_before[i];
				value_after[i] = _value_after[i];
			}
		}
		~MyUndoMethod(){}
	};
	ProjectManager *project;
	SpritesManager *sprites;
	EditsprManager *editspr;
	EditsprDataPage *page;
	SADRS adrs;
	const SpriteDataIterator itr;
	bool unable_edit_change;
private:
	LPCSTR get_template() const{ return "SPRITE_EDIT_DATA_PAGE_CMD8A00"; }
	BOOL Proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
		switch (msg){
			case WM_INITDIALOG:
				init();
				return TRUE;
			case WM_CTLCOLORDLG:
				return (BOOL)(HBRUSH)(COLOR_3DFACE + 1);
			case WM_COMMAND:
				switch (LOWORD(wParam)){
					case IDC_EDIT1:case IDC_EDIT2:case IDC_EDIT3:case IDC_EDIT4:
					case IDC_EDIT5:case IDC_EDIT6:case IDC_EDIT7:case IDC_EDIT8:
					case IDC_EDIT9:case IDC_EDITA:case IDC_EDITB:case IDC_EDITC:
					case IDC_EDITD:
						switch (HIWORD(wParam)){
							case EN_CHANGE:
								edit_change();
								return TRUE;
							case EN_SETFOCUS:
								SendMessage(hWnd, DM_SETDEFID, (WPARAM)IDC_BUTTON21, 0);
								SetFocus(GetDlgItem(hWnd, IDC_BUTTON21));
								SetFocus(GetDlgItem(hWnd, LOWORD(wParam)));
								return TRUE;
						}
						break;
					case IDC_BUTTON21:
						apply();
						return TRUE;
				}
				break;
		}
		return FALSE;
	}
	void init(){
		unable_edit_change = true;
		char s[16];
		for (int i=0; i<13; i++){
			sprintf_s(s, sizeof s, "%04X", itr.get_value_of13(i));
			SendDlgItemMessage(hWnd, IDC_EDIT1+i, EM_SETLIMITTEXT, 4, 0);
			SetDlgItemText(hWnd, IDC_EDIT1+i, s);
		}
		unable_edit_change = false;
	}
	void edit_change(){
		if (unable_edit_change) return;
		SetDlgItemText(hWnd, IDC_STATIC0, "13̕ϐɑ*");
	}
	void apply(){
		char s[16];
		int val;
		WORD value_before[13];
		WORD value_after[13];
		for (int i=0; i<13; i++){
			value_before[i] = itr.get_value_of13(i);
		}
		for (int i=0; i<13; i++){
			GetDlgItemText(hWnd, IDC_EDIT1+i, s, sizeof s);
			if (sscanf_s(s, "%x", &val) < 0 || val < 0 || val > 0xFFFF){
				MessageBox(editspr->get_hWnd(), "lsłB", "G[", MB_OK | MB_ICONEXCLAMATION);
				return;
			}
			value_after[i] = (WORD)val;
		}
		for (int i=0; i<13; i++){
			itr.set_value_of13(value_after[i], i);
		}
		SetDlgItemText(hWnd, IDC_STATIC0, "13̕ϐɑ");
		page->update_command_list(itr);			// f[^y[W̃XgXV
		MyUndoMethod *undo = new MyUndoMethod(editspr, adrs, itr, value_before, value_after);
		project->undo_buffer.add_method(undo);
	}
public:
	EditsprDataPage_Command8A00(
		ProjectManager *_project, SpritesManager *_sprites, EditsprManager *_editspr,
		EditsprDataPage *_page, SADRS _adrs, const SpriteDataIterator &_itr)
		: project(_project), sprites(_sprites), editspr(_editspr), page(_page), adrs(_adrs), itr(_itr)
	{
		create_dialog(page->get_hWnd());
	}
	~EditsprDataPage_Command8A00(){}
};


//	R}h8E00(ľʏƈقȂ)
//-------------------------------------
class EditsprDataPage_Command8E00 : public EditsprDataPage_CommandBase{
	class MyUndoMethod : public UndoMethod{
		EditsprManager *editspr;
		SADRS adrs;
		const SpriteDataIterator itr;
		WORD value_before[4];
		WORD value_after[4];
	private:
		LPCSTR text_undo() const{ return "XvCgf[^̕ύX"; }
		LPCSTR text_redo() const{ return "XvCgf[^̕ύX"; }
		void undo(){
			common(value_before);
		}
		void redo(){
			common(value_after);
		}
		void common(WORD value[4]){
			for (int i=0; i<4; i++) itr.set_value_of4(value[i], i);		// f[^ɔf
			editspr->command(IDM_SPRITE_EDITSPR, 0);					// XvCgҏW_CAO\
			EditsprDataPage *page = editspr->open_data_page(adrs);		// adrs̃y[WJ
			page->update_command_list(itr);					// f[^y[W̃XgXV
			EditsprDataPage_Command8E00 *compage = 
				dynamic_cast<EditsprDataPage_Command8E00*>(page->select_command_page(itr));
			if (!compage) return;
			SetFocus(GetDlgItem(compage->get_hWnd(), IDC_EDIT1));
			SendMessage(compage->get_hWnd(), WM_COMMAND, IDC_EDIT1 | (EN_SETFOCUS<<16), 0);
		}
	public:
		MyUndoMethod(EditsprManager *_editspr, SADRS _adrs, const SpriteDataIterator &_itr,
			WORD _value_before[4], WORD _value_after[4])
			: editspr(_editspr), adrs(_adrs), itr(_itr)
		{
			for (int i=0; i<4; i++){
				value_before[i] = _value_before[i];
				value_after[i] = _value_after[i];
			}
		}
		~MyUndoMethod(){}
	};
	ProjectManager *project;
	SpritesManager *sprites;
	EditsprManager *editspr;
	EditsprDataPage *page;
	SADRS adrs;
	const SpriteDataIterator itr;
	bool unable_edit_change;
private:
	LPCSTR get_template() const{ return "SPRITE_EDIT_DATA_PAGE_CMD8E00"; }
	BOOL Proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
		switch (msg){
			case WM_INITDIALOG:
				init();
				return TRUE;
			case WM_CTLCOLORDLG:
				return (BOOL)(HBRUSH)(COLOR_3DFACE + 1);
			case WM_COMMAND:
				switch (LOWORD(wParam)){
					case IDC_EDIT1:case IDC_EDIT2:case IDC_EDIT3:case IDC_EDIT4:
						switch (HIWORD(wParam)){
							case EN_CHANGE:
								edit_change();
								return TRUE;
							case EN_SETFOCUS:
								SendMessage(hWnd, DM_SETDEFID, (WPARAM)IDC_BUTTON21, 0);
								SetFocus(GetDlgItem(hWnd, IDC_BUTTON21));
								SetFocus(GetDlgItem(hWnd, LOWORD(wParam)));
								return TRUE;
						}
						break;
					case IDC_BUTTON21:
						apply();
						return TRUE;
				}
				break;
		}
		return FALSE;
	}
	void init(){
		unable_edit_change = true;
		char s[16];
		for (int i=0; i<4; i++){
			sprintf_s(s, sizeof s, "%04X", itr.get_value_of4(i));
			SendDlgItemMessage(hWnd, IDC_EDIT1+i, EM_SETLIMITTEXT, 4, 0);
			SetDlgItemText(hWnd, IDC_EDIT1+i, s);
		}
		unable_edit_change = false;
	}
	void edit_change(){
		if (unable_edit_change) return;
		SetDlgItemText(hWnd, IDC_STATIC0, "4̕ϐɑ?*");
	}
	void apply(){
		char s[16];
		int val;
		WORD value_before[4];
		WORD value_after[4];
		for (int i=0; i<4; i++){
			value_before[i] = itr.get_value_of4(i);
		}
		for (int i=0; i<4; i++){
			GetDlgItemText(hWnd, IDC_EDIT1+i, s, sizeof s);
			if (sscanf_s(s, "%x", &val) < 0 || val < 0 || val > 0xFFFF){
				MessageBox(editspr->get_hWnd(), "lsłB", "G[", MB_OK | MB_ICONEXCLAMATION);
				return;
			}
			value_after[i] = (WORD)val;
		}
		for (int i=0; i<4; i++){
			itr.set_value_of4(value_after[i], i);
		}
		SetDlgItemText(hWnd, IDC_STATIC0, "4̕ϐɑ?");
		page->update_command_list(itr);			// f[^y[W̃XgXV
		MyUndoMethod *undo = new MyUndoMethod(editspr, adrs, itr, value_before, value_after);
		project->undo_buffer.add_method(undo);
	}
public:
	EditsprDataPage_Command8E00(
		ProjectManager *_project, SpritesManager *_sprites, EditsprManager *_editspr,
		EditsprDataPage *_page, SADRS _adrs, const SpriteDataIterator &_itr)
		: project(_project), sprites(_sprites), editspr(_editspr), page(_page), adrs(_adrs), itr(_itr)
	{
		create_dialog(page->get_hWnd());
	}
	~EditsprDataPage_Command8E00(){}
};

// R}h8000
class EditsprDataPage_Command8000 : public EditsprDataPage_CommandBase{
private:
	LPCSTR get_template() const{ return "SPRITE_EDIT_DATA_PAGE_CMD8000"; }
	BOOL Proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
		switch (msg){
			case WM_CTLCOLORDLG:
				return (BOOL)(HBRUSH)(COLOR_3DFACE + 1);
		}
		return FALSE;
	}
public:
	EditsprDataPage_Command8000(EditsprDataPage *page){
		create_dialog(page->get_hWnd());
	}
	~EditsprDataPage_Command8000(){}
};


//=============================================================================

//	R}h̕ύX Undo Method
//---------------------------------------------------------
class EditsprSpriteCommand_UndoMethod : public UndoMethod{

	SpritesManager *sprites;
	EditsprManager *editspr;
	SADRS sprite_adrs;
	int data_index;
	const SpriteDataIterator itr;
	const WORD command_before;
	const WORD command_after;

private:
	LPCSTR text_undo() const{ return "XvCgf[^̕ύX"; }
	LPCSTR text_redo() const{ return "XvCgf[^̕ύX"; }
	void undo(){
		common(command_before);
	}
	void redo(){
		common(command_after);
	}
	void common(WORD command){
		char s[256];
		editspr->command(IDM_SPRITE_EDITSPR, 0);						// XvCgҏW_CAO\
		EditsprDataPage *page = editspr->open_data_page(sprite_adrs);	// sprite_num̃y[WJ
		// Xg{bNX
		HWND hwList = GetDlgItem(page->get_hWnd(), IDC_LIST0);
		SendMessage(hwList, WM_SETREDRAW, FALSE, 0);	// page΂Ȃ炱̈Ȁ͕svA炠pageȂKvB
		SpriteDataIterator i = itr;
		do{
			SendMessage(hwList, LB_DELETESTRING, data_index, 0);
		}while(i++);
		itr.set_command(command);
		i = itr;
		int n=data_index;
		do{
			WORD cmd = i.get_command();
			switch (cmd){
				case 0x8000:
					sprintf_s(s, sizeof s, "#%d: 8000", n);
					break;
				case 0x8A00:
					sprintf_s(s, sizeof s, "#%d: 8A00 ( %04X, ... )", n, i.get_value());
					break;
				case 0x8E00:
					sprintf_s(s, sizeof s, "#%d: 8E00 ( %04X, ... )", n, i.get_value());
					break;
				default:
					sprintf_s(s, sizeof s, "#%d: %04X ( %04X )", n, cmd, i.get_value());
					break;
			}
			SendMessage(hwList, LB_INSERTSTRING, n, (LPARAM)s);
			n++;
		}while(i++);
		SendMessage(hwList, LB_SETCURSEL, data_index, 0);
		SendMessage(hwList, WM_SETREDRAW, TRUE, 0);
		page->sel_change(data_index);
		SetFocus(GetDlgItem(page->get_hWnd(), IDC_EDIT1));
		SendMessage(page->get_hWnd(), WM_COMMAND, IDC_EDIT1 | (EN_SETFOCUS<<16), 0);
		return;
	}

public:
	EditsprSpriteCommand_UndoMethod(SpritesManager *_sprites, EditsprManager *_editspr,
		SADRS _sprite_adrs, int _data_index, SpriteDataIterator _itr,
		WORD _command_bef, WORD _command_aft
		)
		: sprites(_sprites), editspr(_editspr),
		sprite_adrs(_sprite_adrs), data_index(_data_index), itr(_itr),
		command_before(_command_bef), command_after(_command_aft)
	{}
	~EditsprSpriteCommand_UndoMethod(){}

};

//=============================================================================


EditsprDataPage::EditsprDataPage(ProjectManager *_project, SpritesManager *_sprites, EditsprManager *_editspr, WORD _adrs)
: project(_project), sprites(_sprites), editspr(_editspr), adrs(_adrs), command_page(NULL)
{
	create_dialog(editspr->get_hWnd());
}

EditsprDataPage::~EditsprDataPage(){
	if (command_page){
		delete command_page;
	}
	destroy();
}



BOOL EditsprDataPage::Proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	WORD id;
	switch (msg){
		case WM_INITDIALOG:
			init();
			return TRUE;
		case WM_CTLCOLORSTATIC:
			if ((HWND)lParam == GetDlgItem(hWnd, IDC_STATICF)) return (BOOL)(COLOR_3DFACE + 1);
            return FALSE;
		case WM_COMMAND:
			switch (id = LOWORD(wParam)){
				case IDC_EDIT1:
					switch (HIWORD(wParam)){
						case EN_CHANGE:
							edit_change();
							return TRUE;
						case EN_SETFOCUS:
							SendMessage(hWnd, DM_SETDEFID, (WPARAM)IDC_BUTTON10, 0);
							SetFocus(GetDlgItem(hWnd, IDC_BUTTON10));
							SetFocus(GetDlgItem(hWnd, IDC_EDIT1));
							return TRUE;
					}
					break;
				case IDC_LIST0:
					switch (HIWORD(wParam)){
						case LBN_SELCHANGE:
							sel_change(SendDlgItemMessage(hDlg, IDC_LIST0, LB_GETCURSEL, 0, 0));
							return TRUE;
						case LBN_SETFOCUS:
							SendMessage(hWnd, DM_SETDEFID, (WPARAM)IDC_BUTTON10, 0);
							SetFocus(GetDlgItem(hWnd, IDC_BUTTON10));
							SetFocus(GetDlgItem(hWnd, IDC_LIST0));
							return TRUE;
					}
					break;
				case IDC_BUTTON10:
					command_apply();
					return TRUE;
				case IDC_BUTTON13:
					close();
					return TRUE;
			}
			if (id >= IDC_BUTTON20 && id <= IDC_BUTTON2F){
				// R}hy[WɑM
				if (command_page){
					return SendMessage(command_page->get_hWnd(), msg, wParam, lParam);
				}
			}
			break;
	}
	return FALSE;
}


void EditsprDataPage::init(){
	unable_edit_change = true;

#ifdef _MSC_VER
	// _CAO̔wi𓧖(^uRg[ɑΉ)
	HMODULE hMod;
	hMod = LoadLibrary("uxtheme.dll");
	if (hMod)
	{
		typedef HRESULT (WINAPI *EnableThemeDialogTexturePROC)(HWND, DWORD);
		EnableThemeDialogTexturePROC pEnableThemeDialogTexture;
		pEnableThemeDialogTexture = (EnableThemeDialogTexturePROC)GetProcAddress(hMod, "EnableThemeDialogTexture");
		if (pEnableThemeDialogTexture)
			pEnableThemeDialogTexture(hWnd, ETDT_ENABLETAB);
		FreeLibrary(hMod);
	}
#endif

	// R}hEl̓͗
	SendDlgItemMessage(hWnd, IDC_EDIT1, EM_SETLIMITTEXT, 4, 0);
	SendDlgItemMessage(hWnd, IDC_EDIT2, EM_SETLIMITTEXT, 4, 0);

	// Xg{bNX
	HWND hwList = GetDlgItem(hWnd, IDC_LIST0);
	int n=0;
	SpriteDataIterator sprite(sprites, adrs);
	do{
		char s[256];
		WORD command = sprite.get_command();
		switch (command){
			case 0x8000:
				sprintf_s(s, sizeof s, "#%d: 8000", n);
				break;
			case 0x8A00:
				sprintf_s(s, sizeof s, "#%d: 8A00 ( %04X, ... )", n, sprite.get_value());
				break;
			case 0x8E00:
				sprintf_s(s, sizeof s, "#%d: 8E00 ( %04X, ... )", n, sprite.get_value());
				break;
			default:
				sprintf_s(s, sizeof s, "#%d: %04X ( %04X )", n, command, sprite.get_value());
				break;
		}
		SendMessage(hwList, LB_INSERTSTRING, n, (LPARAM)s);
		n++;
	}while(sprite++);
	if (n != 0){
		SendMessage(hwList, LB_SETCURSEL, (WPARAM)0, 0);
		sel_change(0);
	}

	unable_edit_change = false;
}


void EditsprDataPage::close(){
	editspr->close_data_page(this);
	return;
}

/*
void EditsprDataPage::size(int width, int height){
	return;
}*/

EditsprDataPage_CommandBase *EditsprDataPage::sel_change(int index){
	unable_edit_change = true;
	RECT rt;
	HWND hwTab = GetDlgItem(editspr->get_hWnd(), IDC_TAB0);
	SetDlgItemText(hWnd, IDC_STATIC1, "R}h:");
	GetWindowRect(GetDlgItem(hWnd, IDC_STATIC1), &rt);
	ScreenToClient(hwTab, (LPPOINT)&rt.left);
	ScreenToClient(hwTab, (LPPOINT)&rt.right);
	InvalidateRect(hwTab, &rt, TRUE);
	InvalidateRect(GetDlgItem(hWnd, IDC_STATIC1), NULL, TRUE);
	SpriteDataIterator sprite(sprites, adrs);
	for (int n=0; n<index; n++) sprite++;
	char s[16];
	sprintf_s(s, sizeof s, "%d", index);
	SetDlgItemText(hWnd, IDC_EDIT0, s);
	sprintf_s(s, sizeof s, "%04X", sprite.get_command());
	GetWindowRect(GetDlgItem(hWnd, IDC_EDIT0), &rt);
	ScreenToClient(hwTab, (LPPOINT)&rt.left);
	ScreenToClient(hwTab, (LPPOINT)&rt.right);
	InvalidateRect(hwTab, &rt, TRUE);
	InvalidateRect(GetDlgItem(hWnd, IDC_EDIT0), NULL, TRUE);
	SetDlgItemText(hWnd, IDC_EDIT1, s);
	unable_edit_change = false;
	return set_command_page(sprite);
}

void EditsprDataPage::edit_change(){
	if (SendDlgItemMessage(hWnd, IDC_LIST0, LB_GETCURSEL, 0, 0) < 0) return;
	if (unable_edit_change) return;
	RECT rt;
	HWND hwTab = GetDlgItem(editspr->get_hWnd(), IDC_TAB0);
	SetDlgItemText(hWnd, IDC_STATIC1, "R}h*:");
	GetWindowRect(GetDlgItem(hWnd, IDC_STATIC1), &rt);
	ScreenToClient(hwTab, (LPPOINT)&rt.left);
	ScreenToClient(hwTab, (LPPOINT)&rt.right);
	InvalidateRect(hwTab, &rt, TRUE);
	InvalidateRect(GetDlgItem(hWnd, IDC_STATIC1), NULL, TRUE);
}

void EditsprDataPage::command_apply(){
	HWND hwList = GetDlgItem(hWnd, IDC_LIST0);
	int index = SendMessage(hwList, LB_GETCURSEL, 0, 0);
	if (index < 0) return;
	char s[1024];
	int val;
	GetDlgItemText(hWnd, IDC_EDIT1, s, sizeof s);
	if (sscanf_s(s, "%x", &val) < 0
		|| val < 0 || val > 0xffff
		)
	{
		MessageBox(editspr->get_hWnd(), "R}h܂B", "G[", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	SpriteDataIterator itr(sprites, adrs);
	for (int i=0; i<index; i++) itr++;
	WORD command_bef = itr.get_command();
	WORD command = (WORD)val;

	if ((command_bef != command) && (
		(command_bef == 0x8000) || (command == 0x8000)
		|| (command_bef == 0x8A00) || (command == 0x8A00)
		|| (command_bef == 0x8E00) || (command == 0x8E00)
		))
	{
		sprintf_s(s, sizeof s, "R}h%04X%04XɕύX悤ƂĂ܂B\r\n"
			"̕ύXsƃf[^TCYωA㑱̃f[^̍\ς邽߁A"
			"lXȖ肪\܂B\r\ns܂?",
			command_bef, command);
		int r = MessageBox(hWnd, s, "x", MB_OKCANCEL | MB_ICONEXCLAMATION);
		if (r != IDOK)
			return;
	}

	SendMessage(hwList, WM_SETREDRAW, FALSE, 0);
	SpriteDataIterator itr2 = itr;
	do{
		SendMessage(hwList, LB_DELETESTRING, index, 0);
	}while(itr2++);

	itr.set_command(command);
	itr2 = itr;
	int n=index;
	do{
		WORD cmd2 = itr2.get_command();
		switch (cmd2){
			case 0x8000:
				sprintf_s(s, sizeof s, "#%d: 8000", n);
				break;
			case 0x8A00:
				sprintf_s(s, sizeof s, "#%d: 8A00 ( %04X, ... )", n, itr2.get_value());
				break;
			case 0x8E00:
				sprintf_s(s, sizeof s, "#%d: 8E00 ( %04X, ... )", n, itr2.get_value());
				break;
			default:
				sprintf_s(s, sizeof s, "#%d: %04X ( %04X )", n, cmd2, itr2.get_value());
				break;
		}
		SendMessage(hwList, LB_INSERTSTRING, n, (LPARAM)s);
		n++;
	}while(itr2++);
	SendMessage(hwList, LB_SETCURSEL, index, 0);
	SendMessage(hwList, WM_SETREDRAW, TRUE, 0);
	RECT rt;			// uR}hv*
	HWND hwTab = GetDlgItem(editspr->get_hWnd(), IDC_TAB0);
	SetDlgItemText(hWnd, IDC_STATIC1, "R}h:");
	GetWindowRect(GetDlgItem(hWnd, IDC_STATIC1), &rt);
	ScreenToClient(hwTab, (LPPOINT)&rt.left);
	ScreenToClient(hwTab, (LPPOINT)&rt.right);
	InvalidateRect(hwTab, &rt, TRUE);
	InvalidateRect(GetDlgItem(hWnd, IDC_STATIC1), NULL, TRUE);
	set_command_page(itr);

	EditsprSpriteCommand_UndoMethod *undo = new EditsprSpriteCommand_UndoMethod(
		sprites, editspr, adrs, index, itr, command_bef, command);
	project->undo_buffer.add_method(undo);
	return;
}

EditsprDataPage_CommandBase *EditsprDataPage::set_command_page(const SpriteDataIterator &itr){
	if (command_page){
		command_page->destroy();
		delete command_page;
		command_page = NULL;
	}
	switch (itr.get_command()){
		case 0x8000:
			command_page = new EditsprDataPage_Command8000(this);
			break;
		case 0x8300:
			command_page = new EditsprDataPage_Command8300(project, sprites, editspr, this, adrs, itr);
			break;
		case 0x8A00:
			command_page = new EditsprDataPage_Command8A00(project, sprites, editspr, this, adrs, itr);
			break;
		case 0x8E00:
			command_page = new EditsprDataPage_Command8E00(project, sprites, editspr, this, adrs, itr);
			break;
		default:
			command_page = new EditsprDataPage_CommandDefault(project, sprites, editspr, this, adrs, itr);
			break;
	}
	RECT rt;
	GetWindowRect(GetDlgItem(hWnd, IDC_STATICF), &rt);
	int w=rt.right - rt.left, h=rt.bottom - rt.top;
	ScreenToClient(hWnd, (LPPOINT)&rt);
	MoveWindow(command_page->get_hWnd(), rt.left, rt.top, w, h, FALSE);
	ShowWindow(command_page->get_hWnd(), SW_SHOW);
	return command_page;
}

EditsprDataPage_CommandBase *EditsprDataPage::select_command_page(const SpriteDataIterator &itr){
	int n=0;
	for (SpriteDataIterator sprite(sprites, adrs); sprite!=itr; sprite++) n++;
	SendDlgItemMessage(hWnd, IDC_LIST0, LB_SETCURSEL, n, 0);
	return sel_change(n);
}

void EditsprDataPage::update_command_list(const SpriteDataIterator &itr){
	int n=0;
	for (SpriteDataIterator sprite(sprites, adrs); sprite!=itr; sprite++) n++;
	HWND hwList = GetDlgItem(hWnd, IDC_LIST0);
	SendMessage(hwList, WM_SETREDRAW, FALSE, 0);
	SendMessage(hwList, LB_DELETESTRING, n, 0);
	char s[256];
	WORD cmd = itr.get_command();
	switch (cmd){
		case 0x8000:
			sprintf_s(s, sizeof s, "#%d: 8000", n);
			break;
		case 0x8A00:
			sprintf_s(s, sizeof s, "#%d: 8A00 ( %04X, ... )", n, itr.get_value());
			break;
		case 0x8E00:
			sprintf_s(s, sizeof s, "#%d: 8E00 ( %04X, ... )", n, itr.get_value());
			break;
		default:
			sprintf_s(s, sizeof s, "#%d: %04X ( %04X )", n, cmd, itr.get_value());
			break;
	}
	SendMessage(hwList, LB_INSERTSTRING, n, (LPARAM)s);
	SendMessage(hwList, LB_SETCURSEL, n, 0);
	SendMessage(hwList, WM_SETREDRAW, TRUE, 0);
	return;
}

void EditsprDataPage::reload(){
	unable_edit_change = true;
	HWND hwList = GetDlgItem(hWnd, IDC_LIST0);
	SendMessage(hwList, WM_SETREDRAW, FALSE, 0);
	SendMessage(hwList, LB_RESETCONTENT, 0, 0);
	int n=0;
	SpriteDataIterator sprite(sprites, adrs);
	do{
		char s[256];
		WORD command = sprite.get_command();
		switch (command){
			case 0x8000:
				sprintf_s(s, sizeof s, "#%d: 8000", n);
				break;
			case 0x8A00:
				sprintf_s(s, sizeof s, "#%d: 8A00 ( %04X, ... )", n, sprite.get_value());
				break;
			case 0x8E00:
				sprintf_s(s, sizeof s, "#%d: 8E00 ( %04X, ... )", n, sprite.get_value());
				break;
			default:
				sprintf_s(s, sizeof s, "#%d: %04X ( %04X )", n, command, sprite.get_value());
				break;
		}
		SendMessage(hwList, LB_INSERTSTRING, n, (LPARAM)s);
		n++;
	}while(sprite++);
	SendMessage(hwList, WM_SETREDRAW, TRUE, 0);
	SendMessage(hwList, LB_SETCURSEL, (WPARAM)0, 0);
	sel_change(0);
	unable_edit_change = false;

	RECT rt;
	HWND hwTab = GetDlgItem(editspr->get_hWnd(), IDC_TAB0);
	SetDlgItemText(hWnd, IDC_STATIC1, "R}h:");
	GetWindowRect(GetDlgItem(hWnd, IDC_STATIC1), &rt);
	ScreenToClient(hwTab, (LPPOINT)&rt.left);
	ScreenToClient(hwTab, (LPPOINT)&rt.right);
	InvalidateRect(hwTab, &rt, TRUE);
	InvalidateRect(GetDlgItem(hWnd, IDC_STATIC1), NULL, TRUE);
}





