
///////////////////////////////////////////////////////////////////////////////
//
//	sprite_find.cpp
//

#include <windows.h>
#include <commctrl.h>
#include "sprite_find.h"
#include "level.h"
#include "project.h"
#include "id.h"
#include "level_sprites.h"


// tHgTCYˑ̒l(LevelFindsprManager::init()Ōv)
static int DIALOG_MARGIN_X=5;
static int DIALOG_MARGIN_Y=5;
static int DIALOG_TEXT_Y=8;
static int DIALOG_TEXT_WIDTH=40;
static int DIALOG_TEXT_HEIGHT=12;
static int DIALOG_EDIT_HEIGHT=14;
static int DIALOG_TYPESEL_WIDTH=15;
static int DIALOG_TYPEBOX_Y=25;
static int DIALOG_TYPEBOX_HEIGHT=22;
static int DIALOG_BUTTON_WIDTH=100;
static int DIALOG_BUTTON_HEIGHT=18;
static int DIALOG_TREE_Y=55;
static int DIALOG_MIN_WIDTH=240;
static int DIALOG_MIN_HEIGHT=320;


FindsprManager::FindsprManager(ProjectManager *_project, SpritesManager *_sprites)
: project(_project), sprites(_sprites)
{
}

FindsprManager::~FindsprManager(){
}

/*BOOL FindsprManager::create(){
	if (!create_dialog(project->get_hWnd())) return FALSE;
	return TRUE;
}*/

void FindsprManager::set_state(BOOL bEnabled){
	HMENU hmMain = GetMenu(project->get_hWnd());
	UINT uState = (bEnabled ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND;
	EnableMenuItem(hmMain, IDM_SPRITE_FINDSPR, uState);
	return;
}


BOOL FindsprManager::command(WPARAM wParam, LPARAM lParam){
	switch (LOWORD(wParam)){
		case IDM_SPRITE_FINDSPR:
			if (!bValid){
				create_dialog(project->get_hWnd());
			}
			ShowWindow(hWnd, SW_SHOW);
			SetFocus(GetDlgItem(hWnd, IDC_EDIT0));
			return TRUE;
	}
	return FALSE;
}


BOOL FindsprManager::Proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	LPNMHDR nmhdr;
	switch (msg){
		case WM_INITDIALOG:
			init();
			return TRUE;
		case WM_SIZING:
			sizing(wParam, lParam);
			return TRUE;
		case WM_SIZE:
			size((SHORT)LOWORD(lParam), (SHORT)HIWORD(lParam));
			return TRUE;
		case WM_NOTIFY:
			nmhdr = (LPNMHDR)lParam;
			if (nmhdr->idFrom == IDC_TREE0 && nmhdr->code == NM_DBLCLK){
				jump_sprite(SendMessage(nmhdr->hwndFrom, LVM_GETNEXTITEM, -1, LVNI_SELECTED));
			}
			break;
		case WM_COMMAND:
			switch (LOWORD(wParam)){
				case IDC_EDIT0:
					if (HIWORD(wParam) == EN_CHANGE){
						type_changed();
					}
					break;
				case IDC_BUTTON0:
					sprite_sel();
					return TRUE;
				case IDOK:		// 
					find();
					return TRUE;
				case IDCANCEL:	// 
					ShowWindow(hWnd, SW_HIDE);
					return TRUE;
			}
			break;
		case WM_DESTROY:
			save_config();
			return TRUE;
	}
	return FALSE;
}

void FindsprManager::init(){
	// tHgTCYˑ̒lv
	RECT rt;
	POINT pt;
	GetWindowRect(GetDlgItem(hWnd, IDC_STATIC0), &rt);
	DIALOG_TEXT_WIDTH = rt.right - rt.left;
	DIALOG_TEXT_HEIGHT = rt.bottom - rt.top;
	pt.x = rt.left;
	pt.y = rt.top;
	ScreenToClient(hWnd, &pt);
	DIALOG_MARGIN_X = pt.x;
	DIALOG_TEXT_Y = pt.y;
	GetWindowRect(GetDlgItem(hWnd, IDC_BUTTON0), &rt);
	DIALOG_EDIT_HEIGHT = rt.bottom - rt.top;
	DIALOG_TYPESEL_WIDTH = rt.right - rt.left;
	pt.x = 0;
	pt.y = rt.top;
	ScreenToClient(hWnd, &pt);
	DIALOG_MARGIN_Y = pt.y;
	GetWindowRect(GetDlgItem(hWnd, IDC_EDIT1), &rt);
	DIALOG_TYPEBOX_HEIGHT = rt.bottom - rt.top;
	pt.x = 0;
	pt.y = rt.top;
	ScreenToClient(hWnd, &pt);
	DIALOG_TYPEBOX_Y = pt.y;
	GetWindowRect(GetDlgItem(hWnd, IDOK), &rt);
	DIALOG_BUTTON_WIDTH = rt.right - rt.left;
	DIALOG_BUTTON_HEIGHT = rt.bottom - rt.top;
	GetWindowRect(GetDlgItem(hWnd, IDC_TREE0), &rt);
	pt.x = 0;
	pt.y = rt.top;
	ScreenToClient(hWnd, &pt);
	DIALOG_TREE_Y = pt.y;
	GetWindowRect(hWnd, &rt);
	DIALOG_MIN_WIDTH = (rt.right - rt.left) * 2 / 3;
	DIALOG_MIN_HEIGHT = DIALOG_MIN_WIDTH * 2 / 3;

	// EBhËʒuƃTCY
	int x = GetPrivateProfileInt("FindSprite", "Pos_X", CW_USEDEFAULT, ConfigFileName);
	int y = GetPrivateProfileInt("FindSprite", "Pos_Y", CW_USEDEFAULT, ConfigFileName);
	int w = GetPrivateProfileInt("FindSprite", "Width", CW_USEDEFAULT, ConfigFileName);
	int h = GetPrivateProfileInt("FindSprite", "Height", CW_USEDEFAULT, ConfigFileName);
	if (!(x == CW_USEDEFAULT || y == CW_USEDEFAULT || w == CW_USEDEFAULT || h == CW_USEDEFAULT)){
		MoveWindow(hWnd, x, y, w, h, FALSE);
	}

	// GfBbgRg[̏
	SendDlgItemMessage(hWnd, IDC_EDIT0, EM_SETLIMITTEXT, 4, 0);

	// Xgr[̏
	HWND hwLView = GetDlgItem(hWnd, IDC_TREE0);
	ListView_SetExtendedListViewStyle(hwLView, LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT | LVS_EX_HEADERDRAGDROP);

	LVCOLUMN column;
	column.mask		= LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	column.fmt		= LVCFMT_LEFT;
	column.iSubItem	= 0;
	column.pszText	= "Xe[W";
	column.cx		= GetPrivateProfileInt("FindSprite", "Column0", 140, ConfigFileName);
	ListView_InsertColumn(hwLView, 0, &column);

	column.mask		= LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	column.fmt		= LVCFMT_LEFT;
	column.iSubItem	= 1;
	column.pszText	= "ԍ";
	column.cx		= GetPrivateProfileInt("FindSprite", "Column1", 45, ConfigFileName);
	ListView_InsertColumn(hwLView, 1, &column);

	column.mask		= LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	column.fmt		= LVCFMT_LEFT;
	column.iSubItem	= 2;
	column.pszText	= "p[^";
	column.cx		= GetPrivateProfileInt("FindSprite", "Column2", 60, ConfigFileName);
	ListView_InsertColumn(hwLView, 2, &column);

	column.mask		= LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	column.fmt		= LVCFMT_LEFT;
	column.iSubItem	= 3;
	column.pszText	= "";
	column.cx		= GetPrivateProfileInt("FindSprite", "Column3", 120, ConfigFileName);
	ListView_InsertColumn(hwLView, 3, &column);

	column.mask		= LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	column.fmt		= LVCFMT_LEFT;
	column.iSubItem	= 4;
	column.pszText	= "X";
	column.cx		= GetPrivateProfileInt("FindSprite", "Column4", 60, ConfigFileName);
	ListView_InsertColumn(hwLView, 4, &column);
	
	column.mask		= LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	column.fmt		= LVCFMT_LEFT;
	column.iSubItem	= 5;
	column.pszText	= "Y";
	column.cx		= GetPrivateProfileInt("FindSprite", "Column5", 60, ConfigFileName);
	ListView_InsertColumn(hwLView, 5, &column);

	return;
}

void FindsprManager::save_config(){
	char s1[32], s2[32];

	RECT rt;
	GetWindowRect(hWnd, &rt);
	sprintf_s(s1, sizeof s1, "%d", rt.left);
	WritePrivateProfileString("FindSprite", "Pos_X", s1, ConfigFileName);
	sprintf_s(s1, sizeof s1, "%d", rt.top);
	WritePrivateProfileString("FindSprite", "Pos_Y", s1, ConfigFileName);
	sprintf_s(s1, sizeof s1, "%d", rt.right - rt.left);
	WritePrivateProfileString("FindSprite", "Width", s1, ConfigFileName);
	sprintf_s(s1, sizeof s1, "%d", rt.bottom - rt.top);
	WritePrivateProfileString("FindSprite", "Height", s1, ConfigFileName);

	LVCOLUMN column;
	HWND hwLView = GetDlgItem(hWnd, IDC_TREE0);
	ZeroMemory(&column, sizeof column);
	column.mask		= LVCF_WIDTH;
	for (int i=0; i<6; i++){
		ListView_GetColumn(hwLView, i, &column);
		sprintf_s(s1, sizeof s1, "Column%d", i);
		sprintf_s(s2, sizeof s2, "%d", column.cx);
		WritePrivateProfileString("FindSprite", s1, s2, ConfigFileName);
	}
}

void FindsprManager::sizing(WPARAM wParam, LPARAM lParam){
	RECT &rt = *(RECT*)lParam;
	if (rt.right - rt.left < DIALOG_MIN_WIDTH){
		switch (wParam){
			case WMSZ_LEFT:
			case WMSZ_TOPLEFT:
			case WMSZ_BOTTOMLEFT:
				rt.left = rt.right - DIALOG_MIN_WIDTH;
				break;
			case WMSZ_RIGHT:
			case WMSZ_TOPRIGHT:
			case WMSZ_BOTTOMRIGHT:
				rt.right = rt.left + DIALOG_MIN_WIDTH;
				break;
		}
	}
	if (rt.bottom - rt.top < DIALOG_MIN_HEIGHT){
		switch (wParam){
			case WMSZ_TOP:
			case WMSZ_TOPLEFT:
			case WMSZ_TOPRIGHT:
				rt.top = rt.bottom - DIALOG_MIN_HEIGHT;
				break;
			case WMSZ_BOTTOM:
			case WMSZ_BOTTOMLEFT:
			case WMSZ_BOTTOMRIGHT:
				rt.bottom = rt.top + DIALOG_MIN_HEIGHT;
				break;
		}
	}
	return;
}

void FindsprManager::size(int width, int height){
	int DIALOG_BUTTON_X = width - DIALOG_MARGIN_X - DIALOG_BUTTON_WIDTH;
	int DIALOG_TYPESEL_X = DIALOG_BUTTON_X - DIALOG_MARGIN_X - DIALOG_TYPESEL_WIDTH;
	MoveWindow(GetDlgItem(hWnd, IDC_EDIT0),
		DIALOG_MARGIN_X+DIALOG_TEXT_WIDTH, DIALOG_MARGIN_Y,
		DIALOG_TYPESEL_X - (DIALOG_MARGIN_X+DIALOG_TEXT_WIDTH), DIALOG_EDIT_HEIGHT, TRUE);
	MoveWindow(GetDlgItem(hWnd, IDC_BUTTON0),
		DIALOG_TYPESEL_X, DIALOG_MARGIN_Y, DIALOG_TYPESEL_WIDTH, DIALOG_EDIT_HEIGHT, TRUE);
	MoveWindow(GetDlgItem(hWnd, IDC_EDIT1), DIALOG_MARGIN_X, DIALOG_TYPEBOX_Y,
		DIALOG_BUTTON_X-DIALOG_MARGIN_X*2, DIALOG_TYPEBOX_HEIGHT, TRUE);
	MoveWindow(GetDlgItem(hWnd, IDOK), DIALOG_BUTTON_X, DIALOG_MARGIN_Y,
		DIALOG_BUTTON_WIDTH, DIALOG_BUTTON_HEIGHT, TRUE);
	MoveWindow(GetDlgItem(hWnd, IDCANCEL),
		DIALOG_BUTTON_X, DIALOG_TYPEBOX_Y+DIALOG_TYPEBOX_HEIGHT-DIALOG_BUTTON_HEIGHT,
		DIALOG_BUTTON_WIDTH, DIALOG_BUTTON_HEIGHT, TRUE);
	MoveWindow(GetDlgItem(hWnd, IDC_TREE0), 0, DIALOG_TREE_Y, width, height-DIALOG_TREE_Y, TRUE);
	return;
}

void FindsprManager::sprite_sel(){
	char s[16];
	int sprite_num;
	GetDlgItemText(hWnd, IDC_EDIT0, s, sizeof s);
	if (sscanf_s(s, "%x", &sprite_num) < 0){
		sprite_num = -1;
	}
	int r = sprites->sprite_select_dialog(hWnd, sprite_num);
	if (r < 0) return;
	sprintf_s(s, sizeof s, "%04X", r);
	SetDlgItemText(hWnd, IDC_EDIT0, s);
	return;
}

void FindsprManager::type_changed(){
	char s[16];
	int sprite_num;
	GetDlgItemText(hWnd, IDC_EDIT0, s, sizeof s);
	if (sscanf_s(s, "%x", &sprite_num) < 0
		|| sprite_num % 2 || sprite_num < 0 || sprite_num >= sprites->get_sprite_count()*2
		)
	{
		SetDlgItemText(hWnd, IDC_EDIT1, "");
		return;
	}
	SetDlgItemText(hWnd, IDC_EDIT1, sprites->get_sprite_name(sprite_num));
	return;
}

void FindsprManager::find(){
	LevelManager *level = &project->levels;
	char s[256];
	char sname[256];
	int sprite_num;
	GetDlgItemText(hWnd, IDC_EDIT0, s, sizeof s);
	if (sscanf_s(s, "%x", &sprite_num) < 0){
		MessageBox(hWnd, "XvCg̎ނ͂ĂB", "XvCg", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	if (sprite_num % 2 || sprite_num < 0 || sprite_num >= sprites->get_sprite_count()*2){
		sprintf_s(s, sizeof s, "XvCg̎ނɎwł̂́A0000ȏ%04X̋16iłB",
			sprites->get_sprite_count()*2);
		MessageBox(hWnd, s, "XvCg", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	sprintf_s(sname, sizeof sname, "%04X: %s", sprite_num, sprites->get_sprite_name(sprite_num));
	HWND hwLView = GetDlgItem(hWnd, IDC_TREE0);
	SendMessage(hwLView, WM_SETREDRAW, FALSE, 0);
	SendMessage(hwLView, LVM_DELETEALLITEMS, 0, 0);
	int i=0;
	int level_count = GetPrivateProfileInt("Sprites", "LevelCount", 224, RomInfoFileName);
	for (int level_num=0; level_num<level_count; level_num++){
		SADRS adrs = project->read_sadrs(0x3E, level_num*2);
		SpriteAllocData data;
		for (int level_sprite_index=0; ; level_sprite_index++){
			data.load_data(project, 0x3E, adrs);
			adrs += 8;
			if (data.param == 0x0000) break;
			if (data.type == (WORD)sprite_num){
				LVITEM item;
				ZeroMemory(&item, sizeof item);

				item.mask		= LVIF_TEXT | LVIF_PARAM;
				sprintf_s(s, sizeof s, "%02X", level_num);
				GetPrivateProfileString("LevelName", s, "?", s+4, (sizeof s)-4, RomInfoFileName);
				s[2] = ':';
				s[3] = ' ';
				item.pszText	= s;
				item.lParam		= (LPARAM)((WORD)level_num | (((DWORD)level_sprite_index)<<16));
				item.iItem		= i;
				item.iSubItem	= 0;
				ListView_InsertItem(hwLView, &item);
				
				item.mask		= LVIF_TEXT;
				sprintf_s(s, sizeof s, "#%d", level_sprite_index);
				item.pszText	= s;
				item.iItem		= i;
				item.iSubItem	= 1;
				ListView_SetItem(hwLView, &item);

				item.mask		= LVIF_TEXT;
				sprintf_s(s, sizeof s, "%04X", data.param);
				item.pszText	= s;
				item.iItem		= i;
				item.iSubItem	= 2;
				ListView_SetItem(hwLView, &item);

				item.mask		= LVIF_TEXT;
				item.pszText	= sname;
				item.iItem		= i;
				item.iSubItem	= 3;
				ListView_SetItem(hwLView, &item);

				item.mask		= LVIF_TEXT;
				sprintf_s(s, sizeof s, "%d", data.pdx);
				item.pszText	= s;
				item.iItem		= i;
				item.iSubItem	= 4;
				ListView_SetItem(hwLView, &item);

				
				item.mask		= LVIF_TEXT;
				sprintf_s(s, sizeof s, "%d", data.pdy);
				item.pszText	= s;
				item.iItem		= i;
				item.iSubItem	= 5;
				ListView_SetItem(hwLView, &item);

				i++;
			}
		};
	}
	SendMessage(hwLView, WM_SETREDRAW, TRUE, 0);
	sprintf_s(s, sizeof s, "%d̃f[^܂B", i);
	MessageBox(hWnd, s, "XvCg", MB_OK | MB_ICONINFORMATION);
	SetFocus(hwLView);
	return;
}

void FindsprManager::jump_sprite(int index){
	LevelManager *level = &project->levels;
	if (index == -1) return;
	HWND hwLView = GetDlgItem(hWnd, IDC_TREE0);
	LVITEM item;
	ZeroMemory(&item, sizeof item);

	item.mask		= LVIF_PARAM;
	item.iItem		= index;
	item.iSubItem	= 0;
	ListView_GetItem(hwLView, &item);
	int level_num = LOWORD(item.lParam);
	int sprite_num = HIWORD(item.lParam);
	if (level_num != level->get_level_num()){
		level->load_level(level_num);			// Xe[WɃWv
		project->level_changed();
	}
	level->sprites.select_sprite(sprite_num);	// XvCgI

	return;
}

BOOL FindsprManager::translate_dialog_message(MSG *msg){
	return bValid && IsDialogMessage(hWnd, msg);
}




